#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Clean, process dates in text files
# 
# Material for the hackathon ENSAE / Red Cross / 2015. Cleaning the data, change encoding.

# In[1]:


get_ipython().run_line_magic('matplotlib', 'inline')
import matplotlib.pyplot as plt
plt.style.use('ggplot')


# In[2]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## prepare data

# In[3]:


import ensae_projects


# In[4]:


get_ipython().run_line_magic('ls', '')


# In[5]:


from ensae_projects.datainc import change_encoding, convert_dates
from pyquickhelper.loghelper import fLOG
fLOG(OutputPrint=True)
fLOG("start")


# In[6]:


def transform(i, line):
    spl = line.split("\t")
    if i == 0:
        spl = [_.replace("_0", "").strip('" ') for _ in spl]
    else:
        spl = [convert_dates(_, 'F').strip('" ') for _ in spl]
    return "\t".join(spl)

change_encoding("SINVOICE_.txt", "SINVOICE_.clean.txt", "latin-1", "latin-1", process=transform, fLOG=fLOG)


# In[7]:


change_encoding("SINVOICEV_.txt", "SINVOICEV_.clean.txt", "latin-1", "latin-1", process=transform, fLOG=fLOG)


# In[8]:


def transform2(i, line):
    spl = line.split(",")
    spl = [convert_dates(_, 'F').strip('" ') for _ in spl]
    return "\t".join(spl)

change_encoding("ITMMASTER.txt", "ITMMASTER.clean.txt", "latin-1", "latin-1", process=transform2, fLOG=fLOG)


# In[9]:


def transform3(i, line):
    spl = line.split(",")
    if i == 0:
        spl = [_.replace("_0", "").strip('" ') for _ in spl]
    else:
        spl = [convert_dates(_, 'F').strip('" ') for _ in spl]
    return "\t".join(spl)

change_encoding("stojou.csv", "stojou.clean.txt", "latin-1", "latin-1", process=transform3, fLOG=fLOG)


# Le dernier exemple est plus lent mais il permet de traiter le où les lignes dont les valeurs incluent le séparateur de colonnes.

# In[10]:


from ensae_projects.datainc import change_encoding_improve, convert_dates
from pyquickhelper.loghelper import fLOG
fLOG(OutputPrint=True)
import re

reg = re.compile(';"(.*?)"')

def transform4(i, line, hist):
    a, b = clean_column_name_sql_dump(i, line, hist)
    return a.replace("_0", ""), b

change_encoding_improve("export_SINVOICE.csv", "export_SINVOICE.clean2.txt", "latin-1", "latin-1", 
                        process=transform4, fLOG=fLOG)